// filemgr

// wb_[
#include <pspkernel.h>
#include <systemctrl.h>
#include <string.h>
#include <stdio.h>
#include "memory.h"

// O[oϐ

// 6.20TN-AœȂ̂́̊֐̂
// NidResolver܂삵ĂȂ݂
// 6.20TN-Bł͏CĂ邩ȁH
SceSize (*sceKernelTotalFreeMemSize_Real)(void);

// ֐
int Read_open(const char *file)
{
	return sceIoOpen(file, PSP_O_RDONLY, 0777);
}

int Write_open(const char *file)
{
	return sceIoOpen(file, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
}

int Make_dir(const char *dirname)
{
	SceUID dfd = sceIoDopen(dirname);
	if(dfd > 0)
	{
		sceIoDclose(dfd);
		return -1;
	}
	else
	{
		sceIoMkdir(dirname, 0777);
		return 0;
	}
}

int Get_size(const char *file)
{
	int size = 0;

	SceUID fd = Read_open(file);
	if(fd > 0)
	{
		sceIoLseek32(fd, 0, PSP_SEEK_SET);
		size = sceIoLseek32(fd, 0, PSP_SEEK_END);
		sceIoLseek32(fd, 0, PSP_SEEK_SET);

		sceIoClose(fd);
	}

	return size;
}

int Caluc_memory(int size, int *n)
{
	// ֐擾
	u32 orgaddr = FindProc("sceSystemMemoryManager", "SysMemUserForUser", 0xF919F628);
	sceKernelTotalFreeMemSize_Real = (void *)orgaddr;

	// malloc_p֐ŃmۂƂsizeof(SceUID)mۂ̂ŁAĂ
	int mem = sceKernelTotalFreeMemSize_Real() - sizeof(SceUID);
	int cal = mem;
	(*n) = 1;

	if(size < mem)
	{
		return size;
	}
	else
	{
		do
		{
			mem += cal;
			(*n) += 1;
		}
		while(size > mem);

		return cal;
	}
}

int Copy_file(const char *old_file, const char *new_file)
{
	SceUID ofd, nfd;
	int size, res, n, i;
	char *buff;

	// vZ
	size = Caluc_memory(Get_size(old_file), &n);

	// t@CI[v
	ofd = Read_open(old_file);
	nfd = Write_open(new_file);

	if(ofd < 0 || nfd < 0) return -1;

	// m
	buff = (char *)malloc_p(sizeof(char) * size);
	if(buff == NULL) return -1;

	for(i = 0; i < n; i++)
	{
		res = sceIoRead(ofd, (void *)buff, size);
		sceIoWrite(nfd, (void *)buff, res);
	}

	// 
	free_p(buff);

	// t@CN[Y
	sceIoClose(ofd);
	sceIoClose(nfd);

	return 0;
}

int Copy_dir(const char *old_dir, const char *new_dir)
{
	int i;
	SceUID dfd;
	SceIoDirent dir;

	char old_path[128];
	char new_path[128];

	dfd = sceIoDopen(old_dir);
	if(dfd < 0) return -1;

	Make_dir(new_dir);

	do
	{
		memset(&dir, 0, sizeof(SceIoDirent));
		i = sceIoDread(dfd, &dir);

		if(i > 0)
		{
			if(strcmp(dir.d_name, ".") == 0 || strcmp(dir.d_name, "..") == 0) continue;

			else
			{
				sprintf(old_path, "%s/%s", old_dir, dir.d_name);
				sprintf(new_path, "%s/%s", new_dir, dir.d_name);

				Copy_file(old_path, new_path);
			}
		}
	}
	while(i > 0);

	sceIoDclose(dfd);
	return 0;
}

int Remove_dir(const char *dirname)
{
	int i;
	SceUID dfd;
	SceIoDirent dir;

	char buff[128];

	dfd = sceIoDopen(dirname);
	if(dfd < 0) return -1;

	do
	{
		memset(&dir, 0, sizeof(SceIoDirent));
		i = sceIoDread(dfd, &dir);

		if(i > 0)
		{
			if(strcmp(dir.d_name, ".") == 0 || strcmp(dir.d_name, "..") == 0) continue;

			else
			{
				sprintf(buff, "%s/%s", dirname, dir.d_name);
				sceIoRemove(buff);
			}
		}
	}
	while(i > 0);

	sceIoDclose(dfd);
	sceIoRmdir(dirname);

	return 0;
}

